from gtcdata.loader import gtcEquilibrium
from gtcdata.visualizer import EquilibriumVisualizer as ev
import matplotlib.pyplot as plt
import numpy as np
import tkinter as tk


def eq_window(selfi, path, file_type):

    if file_type==0:
        filename = path+"/equilibrium.bp"
    elif file_type==1:
        filename = path+"/equilibrium.out"

    # load equilibrium data
    eqdata = gtcEquilibrium(filename, verbose=True)
    #eqdata = gtcEquilibrium(r"./equilibrium.bp", verbose=True)

    # generate plot object
    myEV = ev(eqdata,selfi)
    # test lines:
    #print(myEV._data_file)
    #print(eqdata.torpsi)
    #print(eqdata.q)


    ## functions for GUI

    ## GUI for plots

    window = tk.Toplevel(selfi)
    #window = tk.Tk()
    #window.pack_propagate(0) #prevent the window from shrinking
    window.title("Equilibrium panel")
    #window.geometry('500x300')

    # Plot 1
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)



    def clicked1():
        myEV.plot_Majorradius()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="major", command=clicked1, height=1, width=10)
    btn1.grid(column=1, row=0)

    def clicked2():
        myEV.plot_Minorradius()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="minor", command=clicked2, height=1, width=10)
    btn1.grid(column=1, row=1)


    # Plot 2
    #lbl2 = tk.Label(window, text="Catagory 2", height=1, width=13)
    #lbl2.grid(column=0, row=1)
    def clicked3():
        myEV.plot_Te()
#        plt.show(block=False)
#        plt.show()
    btn2 = tk.Button(window, text="Te", command=clicked3, height=1, width=10)
    btn2.grid(column=1, row=2)
    
    ####
    def clicked4():
        myEV.plot_ne()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="ne", command=clicked4, height=1, width=10)
    btn2.grid(column=1, row=3)

    ####
    def clicked5():
        myEV.plot_Ti()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="Ti", command=clicked5, height=1, width=10)
    btn2.grid(column=1, row=4)



    #####
    def clicked6():
        myEV.plot_ni()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="ni", command=clicked6, height=1, width=10)
    btn2.grid(column=1, row=5)


    #####
    def clicked7():
        myEV.plot_Tf()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="Tf", command=clicked7, height=1, width=10)
    btn2.grid(column=1, row=6)


    #####
    def clicked8():
        myEV.plot_nf()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="nf", command=clicked8, height=1, width=10)
    btn2.grid(column=1, row=7)


    def clicked9():
        myEV.plot_zeff()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="zeff", command=clicked9, height=1, width=10)
    btn2.grid(column=1, row=8)


    # Plot 3
    #lbl3 = tk.Label(window, text="Catagory 3", height=1, width=13)
    #lbl3.grid(column=0, row=2)
    #########################################################################   
    #  def clicked8():
    #  myEV.contour_Jacobian()
    #  plt.show(block=False)
    #btn3 = tk.Button(window, text="Jacobian", command=clicked8, height=1, width=10)
    #btn3.grid(column=1, row=8)

    def clicked10():
        myEV.plot_rotation()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="rotation", command=clicked10, height=1, width=10)
    btn1.grid(column=2, row=0)

    def clicked11():
        myEV.plot_Er()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="Er", command=clicked11, height=1, width=10)
    btn1.grid(column=2, row=1)

    def clicked12():
        myEV.plot_q()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="q", command=clicked12, height=1, width=10)
    btn3.grid(column=2, row=2)

    def clicked13():
        myEV.plot_s()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="s", command=clicked13, height=1, width=10)
    btn3.grid(column=2, row=3)

    def clicked14():
        myEV.plot_g()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="g", command=clicked14, height=1, width=10)
    btn3.grid(column=2, row=4)

    def clicked15():
        myEV.plot_p()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="p", command=clicked15, height=1, width=10)
    btn3.grid(column=2, row=5)

    def clicked16():
        myEV.plot_tor()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="tor", command=clicked16, height=1, width=10)
    btn3.grid(column=2, row=6)

    def clicked17():
        myEV.plot_r()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="r", command=clicked17, height=1, width=10)
    btn3.grid(column=2, row=7)

    def clicked18():
        myEV.plot_rg()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="rg", command=clicked18, height=1, width=10)
    btn3.grid(column=2, row=8)

    def clicked19():
        myEV.plot_psit()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="psi_tor", command=clicked19, height=1, width=10)
    btn3.grid(column=3, row=0)

    def clicked20():
        myEV.plot_psirg()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="psi_rg", command=clicked20, height=1, width=10)
    btn3.grid(column=3, row=1)

    def clicked21():
        myEV.plot_qpsi()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="qpsi", command=clicked21, height=1, width=10)
    btn3.grid(column=3, row=2)

    def clicked22():
        myEV.plot_psir()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="psi_r", command=clicked22, height=1, width=10)
    btn3.grid(column=3, row=3)

    def clicked23():
        myEV.spline_mesh()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="spline_mesh", command=clicked23, height=1, width=10)
    btn3.grid(column=3, row=4)

    def clicked24():
        myEV.plot_bfield()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="bfield", command=clicked24, height=1, width=10)
    btn3.grid(column=3, row=5)

    def clicked25():
        myEV.contour_Jacobian()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="Jacobian", command=clicked25, height=1, width=10)
    btn3.grid(column=3, row=6)

    def clicked26():
        myEV.contour_icurrent()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="icurrent", command=clicked26, height=1, width=10)
    btn3.grid(column=3, row=7)

    def clicked27():
        myEV.contour_zeta2phi()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="zeta2phi", command=clicked27, height=1, width=10)
    btn3.grid(column=3, row=8)

    def clicked28():
        myEV.contour_delta_b()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="delb", command=clicked28, height=1, width=10)
    btn3.grid(column=4, row=0)

    def clicked29():
        myEV.plot_bfield_theta()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="b_theta", command=clicked29, height=1, width=10)
    btn3.grid(column=4, row=1)

    def clicked30():
        #myEV.plot_Jacobian_theta()
        myEV.plot_Jacobian_radi()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="J_r", command=clicked30, height=1, width=10)
    btn3.grid(column=4, row=2)

    def clicked31():
        myEV.plot_spline_err()
#        plt.show(block=False)
    btn3 = tk.Button(window, text="spline_error", command=clicked31, height=1, width=10)
    btn3.grid(column=4, row=3)

    #def clicked32():
    #    pass
    #    plt.show(block=False)
    #btn3 = tk.Button(window, text="window size", command=clicked32, height=1, width=10)
    #btn3.config(state='disabled')
    #btn3.grid(column=4, row=4)



    #############################################
    #def clicked25():
    #    myEV.spline_mesh()
    #    plt.show(block=False)
    #btn3 = tk.Button(window, text="Spline mesh", command=clicked25, height=1, width=10)
    #btn3.grid(column=3, row=6)


    #######################################

    #change the lsp/mpsi range for the plot
    var_m0 = tk.StringVar()
    txt_m0 = tk.Entry(window,width=10,textvariable=var_m0)
    txt_m0.grid(column=5, row=4)
    var_m0.set(myEV.m0)
    var_m1 = tk.StringVar()
    txt_m1 = tk.Entry(window,width=10,textvariable=var_m1)
    txt_m1.grid(column=6, row=4)
    var_m1.set(myEV.m1)
    def clicked_mpsirange():
        if var_m0.get()=="" or var_m1.get()=="":
            var_m0.set(myEV.m0)
            var_m1.set(myEV.m1)
        else:
            myEV.m0 = int(var_m0.get())
            myEV.m1 = int(var_m1.get())
            myEV.idset = range(myEV.m0,myEV.m1+1)
    btn_edit = tk.Button(window, text="mpsi range", command=clicked_mpsirange, height=1, width=10)
    btn_edit.grid(column=4, row=4)

    lb_mrange = tk.Label(window, text = "range: ("+ str(myEV.m0) +', '+ str(myEV.m1) +')')
    lb_mrange.grid(column = 7, row = 4)

    #change the isp value for the radial/theta plots for 2D spdata
    var_isp = tk.StringVar()
    txt_isp = tk.Entry(window,width=10,textvariable=var_isp)
    txt_isp.grid(column=5, row=5)
    var_isp.set(myEV.isp)
    def clicked_isp():
        if var_isp.get()=="":
            var_isp.set(myEV.isp)
        else:
            myEV.isp = int(var_isp.get())
            var_isp.set(myEV.isp)
    btn_edit = tk.Button(window, text="isp", command=clicked_isp, height=1, width=10)
    btn_edit.grid(column=4, row=5)

    lb_cutoff = tk.Label(window, text = "range: ("+ str(0) +', '+ str(myEV._data.npsi-1) +')')
    lb_cutoff.grid(column = 7, row = 5)

    #select the method to refresh figures
    select_plt = tk.IntVar()
    select_plt.set(0)
    def click_slct():
        myEV.plot_mode = int(select_plt.get())
        if myEV.plot_mode == 1:
            print('plot mode changes to "New Figs"')
        elif myEV.plot_mode == 0:
            print('plot mode changes to "Refresh"')
        else:
            print('error: wrong input for plot mode')
    rad1 = tk.Radiobutton(window,text='New Figs', value=1, 
                        variable=select_plt, command=click_slct, width=10)
    rad1.grid(column=4, row=8)
    rad2 = tk.Radiobutton(window,text='Refresh', value=0, 
                        variable=select_plt, command=click_slct, width=10)
    rad2.grid(column=5, row=8)

    #######################################

    # Button to reset all settings of the main window
    def click_reset():
        myEV.m0 = 0
        var_m0.set(myEV.m0)
        myEV.m1 = myEV._data.lsp -1
        var_m1.set(myEV.m1)
        myEV.idset = range(myEV.m0,myEV.m1+1)

        myEV.isp = int(myEV._data.npsi/2)
        var_isp.set(myEV.isp)

        myEV.plot_mode = 0
        select_plt.set(0)
    btn_reset = tk.Button(window, text="reset", fg="red", 
                          command=click_reset, height=1, width=10)
    btn_reset.grid(column=12, row=13)

    # Button to quit the main window
    btn_quit = tk.Button(window, text="Quit", fg="red", 
                        command=window.destroy, height=1, width=10)
    btn_quit.grid(column=13, row=13)

    window.mainloop()

    ## test functions

    #myEV.print_test()
    #input("press Enter...")

    #plt.show(block=False)
    #input("press Enter to close plots")

